#include<LiquidCrystal.h>
// initializare ecran lcd care comunica cu placuta Arduino
LiquidCrystal lcd(12,11,5,4,3,2);
// setare pini pentru senzorul de gaz,potentiometru si buzzer
int smokeA3 = A3;
int potentiometru = A2;
int sensorThres = 500;
#define BUZZER 10
#define BUTTON_PIN 7

// constante pentru calcul
#define R_air 16000 // rezistenta senzorului in aer curat
#define R_sensor 2000
#define exponent -1.4131 // puterea ce caracterizeaza curba variatiei din datasheet
int value = 0;
float gender_voltage = 0;
float pot_th = 2.495; // valoarea tensiunii potentiometrului care face trecerea 
// de la sexul masculin la cel feminin in momentul alegerii
float women_aer = 0.17; // rata de eliminare a alcoolului din aerul expirat in cazul femeilor
float men_aer = 0.12; // rata de eliminare a alcoolului din aerul expirat in cazul barbatilor

String gender;
float float_hours;
int hours;
int minutes;
float concentration, RS_gas, ratio, conc_volt;
double base;

void setup()
{
  // initializare ecran lcd
  lcd.begin(16,2);                
  lcd.setCursor(6, 0);
  lcd.print("Start");
  lcd.setCursor(3, 1);
  // setare pini de output/input
  pinMode(BUZZER, OUTPUT);
  pinMode(BUTTON_PIN, INPUT_PULLUP);
  pinMode(smokeA3, INPUT); 
  pinMode(potentiometru, INPUT);                            
  Serial.begin(9600);
  delay(2000);
}

void loop() {
    // daca butonul estte apasat calculam concentratia prin datele primite
    // de la senzorul MQ-3
    int button_state = digitalRead(BUTTON_PIN);
    if(button_state) {
    // functie care calculeaza concentratia pe baza unor formule
    computeConcentration();
    lcd.clear();
 
    gender_voltage = analogRead(potentiometru);
    // se inregistreaza concentratia de alcool din aerul expirat
    // in functie de sexul persoanei stabilit prin valoarea primita
    // de la potentiometru
    // De asemenea calculam si numarul de ore si minute pana cand alcoolul
    // va fi elimita din organism
    float gender_volt = (float) gender_voltage / 1023 * 5.0; 
    if (0.01 < gender_volt && gender_volt < pot_th) {
      gender = "Male";
      float_hours = (float) concentration / men_aer;
      hours = (int) float_hours;
      minutes = (float_hours - hours) * 60;  
    } else {
      gender = "Female";
      float_hours = concentration / women_aer;
      hours = (int) float_hours;
      minutes = (float_hours - hours) * 60;
    }
    
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print(String(concentration) + "mg/L");
    lcd.setCursor(0, 1);
    lcd.print(gender);
    delay(1500);
    // Stabilim limita legala de alcool la 0.2 pentru ca in unele
    // tari este diferita de cea din romania(unde este 0.0 mg/L)
    lcd.clear();
    if (concentration <= 0.2) {
      lcd.setCursor(0, 0);
      lcd.print("You can drive");
    } else {
      // Daca limita este mai mare decat cea legala se va aprinde buzzerul
      // care ne va instiinta ca nu avem voie sa conducem
      tone(BUZZER, 1000);
      delay(2000);
      noTone(BUZZER);
      delay(2000);
      lcd.setCursor(0, 0);
      lcd.print("You can drive in");
      lcd.setCursor(0, 1);
      lcd.print(String(hours) + "h and " + String(minutes) + "m");
    }
    delay(2000);
  } else {
    // Daca butonul nu este apasat, betivometrul este pregatit pentru o noua
    // masuratoare
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Ready");
    delay(1000);
  }
  value = 0;
}

void computeConcentration() {
    // calculul tensiunii pe care o inregistreaza senzorul in momentul
    // expirarii aerului catre el
    // Facem 10 masuratori pentru o mai mare precizie a calculului
    for (int i = 0; i < 10; i++) {
    value += analogRead(smokeA3);
    }

    value = value / 10;
    conc_volt = (float) (value) / 1023 * 5.0;
    RS_gas = ((5.0 / conc_volt) * R_sensor) - R_sensor;
    ratio = RS_gas / R_air;
    base = 0.4 * ratio;
    concentration = pow(base, exponent) * 0.01 - 0.04;
    concentration = concentration > 0 ? concentration : 0.0;
}